searchNodes=[{"ref":"JsonConfix.Error.html","title":"JsonConfix.Error","type":"exception","doc":"Error custom exception for JsonConfix provider"},{"ref":"JsonConfix.Provider.html","title":"JsonConfix.Provider","type":"module","doc":"This module provides an implementation of Distilery&#39;s configuration provider behavior that changes runtime config tuples for the value. Usage Add the following to your rel/config.exs release :myapp do # ...snip... set config_providers: [ JsonConfix.Provider ] end If your JSON file with the configuration is like this // /path/to/my/secrets.json { &quot;noise&quot;: { ... }, &quot;secrets&quot;: { &quot;data&quot;: { &quot;MY_SECRET&quot;: &quot;***************&quot;, &quot;ANOTHER_SECRET&quot;: &quot;**************&quot; } }, &quot;more_noise&quot;: { ... } } Your configuration should look like: config :json_confix, file_path: &quot;/path/to/my/secrets.json&quot; # Defaults to /tmp/json_confix.json, json_keys: [&quot;secrets&quot;, &quot;data&quot;] This will result in JsonConfix.Provider being invoked during boot, at which point it will evaluate the current configuration for all the apps and replace the config tuples when needed, persisting it in the configuration. Configuration tuples The json config tuple always start with :json, and can have some options as keyword, the syntax are like this: {:json, env_name} {:json, env_name, opts} The available options are: type: Type to cast the value, one of :string, :integer, :atom, :boolean. Default to :string default: Default value if the key is not persent in the JSON file. Default no nil transform: Function to transform the final value, the syntax is {Module, :function} required: Set to true if this key is not persent in the JSON file, if not setted it will raise an error. Default no false For example: {:json, &quot;MYSQL_PORT&quot;, type: :integer, default: 3306} {:json, &quot;ENABLE_LOG&quot;, type: :boolean, default: false} {:json, &quot;HOST&quot;, transform: {MyApp.UrlParser, :parse}} If you need to store the literal values {:json, term()}, {:json, term(), Keyword.t()}, you can use {:json, :literal, term()} to disable JsonConfix config interpolation. For example: {:json, :literal, {:json, &quot;HOST}}"},{"ref":"JsonConfix.Provider.html#replace/1","title":"JsonConfix.Provider.replace/1","type":"function","doc":""},{"ref":"readme.html","title":"JsonConfix","type":"extras","doc":"JsonConfix JsonConfix provides a Distillery release config provider that replaces config tuples (e.g {:json, value}) with values read from a JSON file. Most of the code has been taken from ConfigTuples"},{"ref":"readme.html#installation","title":"JsonConfix - Installation","type":"extras","doc":"If available in Hex, the package can be installed by adding json_confix to your list of dependencies in mix.exs: def deps do [ {:json_confix, &quot;~&gt; 0.2.0&quot;} ] end"},{"ref":"readme.html#usage","title":"JsonConfix - Usage","type":"extras","doc":"If your JSON file with the configuration is like this // /path/to/my/secrets.json { &quot;noise&quot;: { ... }, &quot;secrets&quot;: { &quot;data&quot;: { &quot;MY_SECRET&quot;: &quot;***************&quot;, &quot;ANOTHER_SECRET&quot;: &quot;**************&quot; } }, &quot;more_noise&quot;: { ... } } Your configuration should look like: config :json_confix, file_path: &quot;/path/to/my/secrets.json&quot; # Defaults to /tmp/json_confix.json, json_keys: [&quot;secrets&quot;, &quot;data&quot;] Documentation can be generated with ExDoc and published on HexDocs. Once published, the docs can be found at https://hexdocs.pm/json_confix."}]